SharedSignalsFrameworkSSFApi
The SSF Transmitter Service is a security event notification system that monitors identity attribute changes and automatically triggers session revocation events when specific lifecycle conditions are met.
Use this API to implement transmitter functionality so administrators can discover the transmitter and manage streams. Transmitters send identity data and events from Identity Security Cloud to external receivers over the Secure Sync Framework (SSF). The SSF configuration and JWKS endpoints support discovery and verification; the stream management endpoints support creating, updating, and managing streams and verifying receivers. In Identity Security Cloud, administrators can use the "Connections" > "Shared Signals" area to view and manage transmitters and their streams.
All URIs are relative to https://sailpoint.api.identitynow.com
| Method | HTTP request | Description |
|---|---|---|
| create-stream-v1 | POST /ssf/v1/streams | Create stream |
| delete-stream-v1 | DELETE /ssf/v1/streams | Delete stream |
| get-jwks-data-v1 | GET /ssf/v1/jwks | Get JWKS |
| get-ssf-configuration-v1 | GET /.well-known/v1/ssf-configuration | Get SSF configuration |
| get-stream-status-v1 | GET /ssf/v1/streams/status | Get stream status |
| get-stream-v1 | GET /ssf/v1/streams | Get stream(s) |
| send-stream-verification-v1 | POST /ssf/v1/streams/verify | Verify stream |
| set-stream-configuration-v1 | PUT /ssf/v1/streams | Replace stream configuration |
| update-stream-configuration-v1 | PATCH /ssf/v1/streams | Update stream configuration |
| update-stream-status-v1 | POST /ssf/v1/streams/status | Update stream status |
create-stream-v1
Create stream An SSF stream is associated with the client ID of the OAuth 2.0 access token used to create the stream. One SSF stream is allowed for each client ID.
You can create a maximum of 10 SSF stream configurations for one org.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| createStreamRequest | CreateStreamRequest |
Return type
StreamConfigResponse
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { CreateStreamRequest } from 'sailpoint-api-client/dist/shared_signals_framework_ssf/api';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const createStreamRequest: CreateStreamRequest = {
"delivery" : {
"method" : "urn:ietf:rfc:8935",
"endpoint_url" : "https://receiver.example.com/ssf/events",
"authorization_header" : "Bearer eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9..."
},
"description" : "Production event stream",
"events_requested" : [ "https://schemas.openid.net/secevent/caep/event-type/session-revoked" ]
}; //
const result = await apiInstance.createStreamV1({ createStreamRequest: createStreamRequest });
console.log(result);
delete-stream-v1
Delete stream
Deletes a stream by its ID. There is no request body; the stream is identified by the required
query parameter stream_id. On success the response has no body (204 No Content).
The associated stream with the client ID (through the request OAuth 2.0 access token) is deleted.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| streamId | string | ID of the stream to delete. Required; omitted or empty returns 400. | [default to undefined] |
Return type
(empty response body)
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const streamId: string = 550e8400-e29b-41d4-a716-446655440000; // ID of the stream to delete. Required; omitted or empty returns 400.
const result = await apiInstance.deleteStreamV1({ streamId: streamId });
console.log(result);
get-jwks-data-v1
Get JWKS Returns the transmitter's JSON Web Key Set (JWKS) for verifying signed delivery requests.
Parameters
This endpoint does not need any parameter.
Return type
JWKS
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const result = await apiInstance.getJWKSDataV1({ });
console.log(result);
get-ssf-configuration-v1
Get SSF configuration Returns the SSF transmitter discovery metadata (well-known configuration).
Parameters
This endpoint does not need any parameter.
Return type
TransmitterMetadata
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const result = await apiInstance.getSSFConfigurationV1({ });
console.log(result);
get-stream-status-v1
Get stream status Returns the status (enabled, paused, disabled) and optional reason for the stream associated with the client ID of the request's OAuth 2.0 access token. The stream_id query parameter is required.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| streamId | string | ID of the stream whose status to retrieve. | [default to undefined] |
Return type
StreamStatusResponse
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const streamId: string = 550e8400-e29b-41d4-a716-446655440000; // ID of the stream whose status to retrieve.
const result = await apiInstance.getStreamStatusV1({ streamId: streamId });
console.log(result);
get-stream-v1
Get stream(s) Retrieves either a list of all SSF stream configurations or the individual configuration if specified by ID.
As stream configurations are tied to a client ID, you can only view the stream associated with the client ID of the request OAuth 2.0 access token.
Query parameter aud (co filter) can be used to filter by audience.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| streamId | string | If provided, returns that stream; otherwise returns list of all streams. | [optional] [default to undefined] |
Return type
GetStreamV1200Response
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const streamId: string = 550e8400-e29b-41d4-a716-446655440000; // If provided, returns that stream; otherwise returns list of all streams. (optional)
const result = await apiInstance.getStreamV1({ });
console.log(result);
send-stream-verification-v1
Verify stream Verifies an SSF stream by publishing a verification event requested by a security events provider.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| verificationRequest | VerificationRequest |
Return type
(empty response body)
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { VerificationRequest } from 'sailpoint-api-client/dist/shared_signals_framework_ssf/api';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const verificationRequest: VerificationRequest = {
"stream_id" : "550e8400-e29b-41d4-a716-446655440000",
"state" : "verification-challenge-state-123"
}; //
const result = await apiInstance.sendStreamVerificationV1({ verificationRequest: verificationRequest });
console.log(result);
set-stream-configuration-v1
Replace stream configuration Replaces a stream's configuration (PUT). stream_id and delivery are required; full receiver-supplied properties.
The associated stream with the client ID (through the request OAuth 2.0 access token) is replaced.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| replaceStreamConfigurationRequest | ReplaceStreamConfigurationRequest |
Return type
UpdateStreamConfigResponse
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { ReplaceStreamConfigurationRequest } from 'sailpoint-api-client/dist/shared_signals_framework_ssf/api';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const replaceStreamConfigurationRequest: ReplaceStreamConfigurationRequest = {
"delivery" : {
"method" : "urn:ietf:rfc:8935",
"endpoint_url" : "https://receiver.example.com/ssf/events",
"authorization_header" : "Bearer eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9..."
},
"stream_id" : "550e8400-e29b-41d4-a716-446655440000",
"description" : "Production event stream",
"events_requested" : [ "https://schemas.openid.net/secevent/caep/event-type/session-revoked" ]
}; //
const result = await apiInstance.setStreamConfigurationV1({ replaceStreamConfigurationRequest: replaceStreamConfigurationRequest });
console.log(result);
update-stream-configuration-v1
Update stream configuration Partially updates a stream's configuration (PATCH). Only provided fields are updated.
The associated stream with the client ID (through the request OAuth 2.0 access token) is updated.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| updateStreamConfigurationRequest | UpdateStreamConfigurationRequest |
Return type
UpdateStreamConfigResponse
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { UpdateStreamConfigurationRequest } from 'sailpoint-api-client/dist/shared_signals_framework_ssf/api';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const updateStreamConfigurationRequest: UpdateStreamConfigurationRequest = {
"delivery" : {
"method" : "urn:ietf:rfc:8935",
"endpoint_url" : "https://receiver.example.com/ssf/events",
"authorization_header" : "Bearer eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9..."
},
"stream_id" : "550e8400-e29b-41d4-a716-446655440000",
"description" : "Updated production event stream configuration",
"events_requested" : [ "https://schemas.openid.net/secevent/caep/event-type/session-revoked" ]
}; //
const result = await apiInstance.updateStreamConfigurationV1({ updateStreamConfigurationRequest: updateStreamConfigurationRequest });
console.log(result);
update-stream-status-v1
Update stream status Updates the operational status (enabled, paused, disabled) with an optional reason for the stream associated with the client ID of the request's OAuth 2.0 access token.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| updateStreamStatusRequest | UpdateStreamStatusRequest |
Return type
StreamStatusResponse
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { SharedSignalsFrameworkSSFApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { UpdateStreamStatusRequest } from 'sailpoint-api-client/dist/shared_signals_framework_ssf/api';
const configuration = new Configuration();
const apiInstance = new SharedSignalsFrameworkSSFApi(configuration);
const updateStreamStatusRequest: UpdateStreamStatusRequest = {
"reason" : "manually paused",
"stream_id" : "550e8400-e29b-41d4-a716-446655440000",
"status" : "paused"
}; //
const result = await apiInstance.updateStreamStatusV1({ updateStreamStatusRequest: updateStreamStatusRequest });
console.log(result);